Summary: Extension for spComponent GUI toolkit 
Name: spComponentEx
Version: 0.5.2
Release: 5
License: distributable
Distribution: (none)
Vendor: (none)
Group: Development/Libraries
Source: %{name}-%{version}-%{release}.tgz
Packager: Hideki Banno
URL: https://www-ie.meijo-u.ac.jp/labs/rj001/spLibs/index.html
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%if 0%{?rhel} >= 8
Requires: gtk3-devel, spBase >= 0.8.25, spComponent >= 0.6.23
BuildRequires: findutils, gtk3-devel, openmotif-devel, libXpm-devel, mesa-libGLw-devel, mesa-libGLU-devel, spBase >= 0.8.25, spComponent >= 0.6.23, spComponent-motif >= 0.6.23
%else
Requires: gtk3-devel, gtk2-devel, gtkglext-devel, spBase >= 0.8.25, spComponent >= 0.6.23
BuildRequires: findutils, gtk3-devel, gtk2-devel, gtkglext-devel, openmotif-devel, libXpm-devel, mesa-libGLw-devel, mesa-libGLU-devel, spBase >= 0.8.25, spComponent >= 0.6.23, spComponent-motif >= 0.6.23
%endif
%define __spec_install_post /usr/lib/rpm/brp-compress || :

%description 
spComponentEx is an extension set of spComponent which is a GUI toolkit
working on multiple platforms.

%package motif
Summary: Extension for spComponent GUI toolkit (Motif version)
Group: Development/Libraries
Requires: openmotif-devel, libXpm-devel, mesa-libGLw-devel, spBase >= 0.8.25, spComponent >= 0.6.23, spComponent-motif >= 0.6.23, spComponentEx = %{version}-%{release}
%description motif
spComponentEx is an extension set of spComponent which is a GUI toolkit
working on multiple platforms. This package includes spComponentEx of 
Motif version.

%changelog
* Tue May 29 2025  Hideki Banno
- Version 0.5.2-5

* Fri May 31 2024  Hideki Banno
- Version 0.5.2-4

* Mon Jan 07 2019  Hideki Banno
- Version 0.5.2-3

* Sat Nov 12 2016  Hideki Banno
- Version 0.5.2-2

* Mon May 16 2016  Hideki Banno
- Version 0.5.2

* Tue Dec 22 2015  Hideki Banno
- Version 0.5.1

* Tue Aug  5 2014  Hideki Banno
- Version 0.5.0

* Wed Aug  1 2012  Hideki Banno
- Version 0.4.0

* Sat Feb 14 2009  Hideki Banno
- 1st release

%prep
%setup -q
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_prefix}

%build
%define debug_package %{nil}
cd spComponentEx
cd example
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} cleanbin
cp Makefile Makefile.org
cp Makefile.main Makefile.main.org
%{__sed} -e "s|\.\./\.\.|%{_prefix}|" -e "s|= lib|= %{_lib}|" Makefile.org > Makefile
%{__sed} -e "s|\.\./\.\.|%{_prefix}|" -e "s|= lib|= %{_lib}|" Makefile.main.org > Makefile.main
%{__rm} -f Makefile.org Makefile.main.org
%{__rm} -f *.r
%{__rm} -f *.bmp
%{__rm} -f *.aps
%{__rm} -f *.rc
%{__rm} -f *.ico
%{__rm} -f *.suo
%{__rm} -f *.sln
%{__rm} -f *.make
%{__rm} -rf vc
%{__rm} -rf Debug*
%{__rm} -rf debug*
%{__rm} -rf Release*
%{__rm} -rf release*
%{__rm} -rf x64
%{__rm} -rf xcode
%{__rm} -rf cocoa
%{__rm} -rf ios

mkfiles=`find android -name Android.mk`
for mkfile in ${mkfiles} ; do
    %{__sed} -i \
	-e 's|SP_INCLUDE_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./include|SP_INCLUDE_TOP := /usr/share/sp/include|g' \
	-e 's|SP_BASE_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spBase|SP_BASE_TOP := /usr/share/sp/spBase|g' \
	-e 's|SP_BASE_LIB_LOCAL := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spBase/android/obj/local|SP_BASE_LIB_LOCAL := $(SP_BASE_TOP)/android/obj/local|g' \
	-e 's|SP_COMPONENT_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spComponent|SP_COMPONENT_TOP := /usr/share/sp/spComponent|g' \
	-e 's|SP_COMPONENT_ANDROID_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spComponent|SP_COMPONENT_ANDROID_TOP := /usr/share/sp/spComponent|g' \
	-e 's|SP_COMPONENTEX_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spComponentEx|SP_COMPONENTEX_TOP := /usr/share/sp/spComponent|g' \
	"${mkfile}"
done

cd ..

cd ..

%install
cd spComponentEx
if [ -d /usr/include/gtk-3.0 ]; then
    gtk3_minor_version=`awk '/#define GTK_MINOR_VERSION/ { print $3}' /usr/include/gtk-3.0/gtk/gtkversion.h | sed 's/(\([0-9]*\))/\1/g'`
    if [ ${gtk3_minor_version} -ge 16 ] ; then
	%{__make} USE_GTK3=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
	%{__make} USE_GTK3=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
    fi
    if [ -f /usr/include/gtkglext-1.0/gtk/gtkgl.h ]; then
	%{__make} USE_GTK2=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
	%{__make} USE_GTK2=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
    fi
else
    %{__make} USE_GTK2=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
    %{__make} USE_GTK2=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
fi
%{__make} USE_GTK=n USE_MOTIF=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
%{__make} USE_GTK=n USE_MOTIF=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
cd ..
%{__strip} --remove-section=.comment --remove-section=.note --strip-debug %{buildroot}%{_libdir}/lib*.a
if [ -f %{buildroot}%{_libdir}/libspcex-gtk.linux-glibc.a ]; then
    %{__ln_s} libspcex-gtk.linux-glibc.a %{buildroot}%{_libdir}/libspcex-gtk.linux.a
fi
if [ -f %{buildroot}%{_libdir}/libspcex-gtk2.linux-glibc.a ]; then
    %{__ln_s} libspcex-gtk2.linux-glibc.a %{buildroot}%{_libdir}/libspcex-gtk2.linux.a
fi
if [ -f %{buildroot}%{_libdir}/libspcex-gtk3.linux-glibc.a ]; then
    %{__ln_s} libspcex-gtk3.linux-glibc.a %{buildroot}%{_libdir}/libspcex-gtk3.linux.a
fi
if [ -f %{buildroot}%{_libdir}/libspcex.linux-glibc.a ]; then
    %{__ln_s} libspcex.linux-glibc.a %{buildroot}%{_libdir}/libspcex.linux.a
fi

%clean
%{__rm} -rf %{buildroot}

%pre
%post
%preun
%postun

%files 
%defattr(-,root,root)
%doc spComponentEx/README* spComponentEx/CHANGES* spComponentEx/LICENSE*
%doc spComponentEx/example
%{_libdir}/libspcex-gtk*.a
%{_includedir}/sp/spGL.h
%{_includedir}/sp/spGLP.h
%{_includedir}/sp/spGLShader.h
%{_includedir}/sp/spGLShaderP.h
%{_includedir}/sp/spGLString.h
%{_includedir}/sp/spGLStringP.h
%{_includedir}/sp/spGLPhongModel.h
%{_includedir}/sp/spGL_Gtk.h
%{_includedir}/sp/spGLShader_Gtk.h
%{_includedir}/sp/spGLString_Gtk.h

%files motif
%defattr(-,root,root)
%{_libdir}/libspcex.*.a
%{_includedir}/sp/spGL_Xm.h
%{_includedir}/sp/spGLShader_Xm.h
%{_includedir}/sp/spGLString_Xm.h
